#pragma once

#include <netinet/ip_icmp.h>
#include <netinet/tcp.h>
#include <netinet/udp.h>
#include <stdint.h>

#include "scan.h"

typedef enum {
	OPEN = 1,
	CLOSE,
	FILTERED,
	UNFILTERED,
	OPENFILTERED,
} e_state;

struct response {
	uint16_t port;
	e_state state;
	char *service;
};

void tcp_response(const struct tcphdr *tcphdr, const struct scan *data);
void udp_response(const struct udphdr *udphdr, const struct scan *data);
void icmp_response(const struct icmphdr *icmphdr, const struct scan *data);
