#include <netinet/in.h>
#include <stdint.h>
#include <stdio.h>

#include "scan.h"
#include "thread.h"

void *routine(void *p_data)
{
	struct thread *thread_data = (struct thread *)p_data;
	struct scan scan_data = {
	    .dest_addr = thread_data->dest_addr,
	    .host = &thread_data->host,
	    .port_start = thread_data->port_start,
	    .type = thread_data->type,
	};

	for (uint16_t port = thread_data->port_start;
	     port <= thread_data->port_end; port++) {
		scan_data.port = port;
		scan_data.response =
		    &thread_data->responses[port - thread_data->port_start];
		if (scan(&scan_data))
			return NULL;
		printf("%d: %s\n", port,
		       scan_data.response->state == 1 ? "OPEN" : "CLOSED");
	}

	return p_data;
}
